{#-#####################################################################
 # Helper macros common to all network frameworks
 #======================================================================
 # This file provides common Jinja macros which are required to generate
 # network configurations for any network framework.
 ####################################################################-#}
{#======================================================================
 # Get native bond hash policy
 #----------------------------------------------------------------------
 # This macro is reponsible for translating hash policy identifiers used
 # in the interface configuration to native policy names on the target
 # framework.
 #
 # Parameters:
 #    - mode (str)    The interface bond mode. This parameter is needed
 #                    to make the macro remain silent when the bonding
 #                    mode does not support hash policies.
 #    - policy (str)  The hash policy identifier of the bond interface.
 #===================================================================-#}
{%- macro get_bond_native_hash_policy(mode, policy) -%}
  {%- if mode in ['hash', 'lacp', 'tlbh', 'alb'] -%}

    {#- ifupdown framework -#}
    {%- if role__sys_net_interfaces__framework in ['ifupdown'] -%}
      {%-   if policy in ['layer2'] -%}
        {{ "layer2" }}
      {%- elif policy in ['layer23', 'layer3'] -%}
        {{ "layer2+3" }}
      {%- elif policy in ['layer24', 'layer234', 'layer34', 'layer4'] -%}
        {{ "layer3+4" }}
      {%- elif policy in ['encap23'] -%}
        {{ "encap2+3" }}
      {%- elif policy in ['encap34'] -%}
        {{ "encap3+4" }}
      {%- endif -%}

    {#- freebsd_rc framework -#}
    {%- elif role__sys_net_interfaces__framework in ['ifupdown'] -%}
      {%-   if policy in ['layer2'] -%}
        {{ "l2" }}
      {%- elif policy in ['layer3'] -%}
        {{ "l3" }}
      {%- elif policy in ['layer23', 'encap23'] -%}
        {{ "l2,l3" }}
      {%- elif policy in ['layer4'] -%}
        {{ "l4" }}
      {%- elif policy in ['layer24'] -%}
        {{ "l2,l4" }}
      {%- elif policy in ['layer34', 'encap34'] -%}
        {{ "l3,l4" }}
      {%- elif policy in ['layer234'] -%}
        {{ "l2,l3,l4" }}
      {%- endif -%}

    {#- Unknown framework -#}
    {%- else -%}
      {{ None }}
    {%- endif -%}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Get native bonding mode
 #----------------------------------------------------------------------
 # This macro is reponsible for translating bond mode identifiers used
 # in the interface configuration to native mode names on the target
 # framework.
 #
 # Parameters:
 #    - mode (str)    The interface bond mode.
 #===================================================================-#}
{%- macro get_bond_native_mode(mode) -%}
  {#- ifupdown framework -#}
  {%- if role__sys_net_interfaces__framework in ['ifupdown'] -%}
    {%-   if mode in ['broadcast'] -%}
      {{ "broadcast" }}
    {%- elif mode in ['failover'] -%}
      {{ "active-backup" }}
    {%- elif mode in ['hash'] -%}
      {{ "balance-xor" }}
    {%- elif mode in ['lacp'] -%}
      {{ "802.3ad" }}
    {%- elif mode in ['roundrobin'] -%}
      {{ "balance-rr" }}
    {%- elif mode in ['tbld', 'tblh'] -%}
      {{ "balance-tlb" }}
    {%- elif mode in ['alb'] -%}
      {{ "balance-alb" }}
    {%- endif -%}

  {#- freebsd_rc framework -#}
  {%- elif role__sys_net_interfaces__framework in ['freebsd_rc'] -%}
    {%-   if mode in ['broadcast'] -%}
      {{ "broadcast" }}
    {%- elif mode in ['failover'] -%}
      {{ "failover" }}
    {%- elif mode in ['hash', 'tlbh'] -%}
      {{ "loadbalance" }}
    {%- elif mode in ['lacp'] -%}
      {{ "lacp" }}
    {%- elif mode in ['roundrobin', 'tlbd', 'alb'] -%}
      {{ "roundrobin" }}
    {%- endif -%}

  {#- Unknown framework -#}
  {%- else -%}
    {{ None }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Get device name from interface
 #----------------------------------------------------------------------
 # Echoes the device name of the network interface matching the supplied
 # interface definition. The value is not generated by the macro, but
 # fetched from the supplied indexes.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #    - native    (bool) Whether to echo a native device name.
 #
 # If the ``native`` parameter is set to ``true``, the macro shall
 # echo a device name native to the remote platform, i.e. an original
 # device name before device renaming rules are applied.
 #===================================================================-#}
{%- macro get_device_name_from_interface(
      interface,
      indexes,
      native=false)
-%}
  {%- if native == true -%}
    {{ indexes['native_device_names'][interface['uid']] }}
  {%- else -%}
    {{ indexes['final_device_names'][interface['uid']] }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Get device name from interface uid
 #----------------------------------------------------------------------
 # Echoes the device name of the network interface matching the supplied
 # uid. The value is not generated by the macro, but fetched from
 # the supplied indexes.
 #
 # Parameters:
 #    - uid     (str)   The unique identifier  of the targeted interface
 #    - indexes (dict)  Interface indexes built by the main.j2 template
 #    - native  (bool)  Whether to echo a native device name.
 #
 # If the ``native`` parameter is set to ``true``, the macro shall
 # echo a device name native to the remote platform, i.e. an original
 # device name before device renaming rules are applied.
 #===================================================================-#}
{%- macro get_device_name_from_interface_uid(
      uid,
      indexes,
      native=false)
-%}
  {%- set interface = indexes['valid_interfaces'][uid] -%}
  {{ get_device_name_from_interface(interface, indexes, native) }}
{%- endmacro -%}

{#======================================================================
 # Get device names from interface uids
 #----------------------------------------------------------------------
 # Echoes a list of device names for the network interfaces matching the
 # supplied uids. The values are not generated by the macro, but fetched
 # from the supplied indexes.
 #
 # Parameters:
 #    - uids    (str[]) The unique identifiers of targeted interfaces
 #    - indexes (dict)  Interface indexes built by the main.j2 template
 #    - native  (bool)  Whether to echo a native device name.
 #
 # If the ``native`` parameter is set to ``true``, the macro shall
 # echo device names native to the remote platform, i.e. original device
 # names before device renaming rules are applied.
 #===================================================================-#}
{%- macro get_device_names_from_interface_uids(
      uids,
      indexes,
      native=false)
-%}
  {%- set device_names = [] -%}

  {%- for uid in uids -%}
    {%- set interface = indexes['valid_interfaces'][uid] -%}
    {%- set device_name =
        get_device_name_from_interface(interface, indexes, native) -%}
    {{ device_names.append(device_name) }}
  {%- endfor -%}

  {{ device_names | to_json }}
{%- endmacro -%}
